global santexToolbox_create
--include_tools = #()
rcmenu menu_vars
(
	menuItem mi_on "Enabled"-- checked:false
	separator sep0 ""
	menuitem mi_edit "Edit"
	menuitem mi_add "Add"
	menuitem mi_dupl "Duplicate" enabled:false
	menuitem mi_del "Delete"
	menuitem mi_del_all "Delete all"
	separator sep1 ""
	menuItem mi_none "<None>"-- checked:true
	menuItem mi_edt "Edittext (Expression)"
	menuItem mi_integer "Spinner (Integer)"
	menuItem mi_float "Spinner (Float)"
	menuItem mi_pick "Pickbutton (<Node>)"
	menuItem mi_bool "Checkbox (Boolean)"
	menuItem mi_custom "<User specified>"
	
	on mi_on picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection].use = NOT mi_on.checked
		santexToolbox_create.refresh_var_list()
	)
	
	on mi_edit picked do
	(
		try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_edit_var.ms"
	)
	on mi_add picked do
	(
		try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_add_var.ms" 
	)
	on mi_dupl picked do
	(
		try(destroydialog santexToolbox_add_var)catch()
		
		local new_var = copy all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection]
		new_var.name = new_var.name+"_cpy"
		santexToolbox_create.add_new_var new_var
	)	
	on mi_del picked do
	(
		if(querybox "Do you really want to delete selected parameter?" title:"santexToolbox")do
		(
			deleteItem all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars (santexToolbox_create.lbx_vars.selection)
			santexToolbox_create.refresh_var_list()
		)
	)
	on mi_del_all picked do
	(
		if(querybox "Do you really want to delete all parameters?" title:"santexToolbox")do
		(
			--deleteItem all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars (santexToolbox_create.lbx_vars.selection)
			all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars = #()
			santexToolbox_create.refresh_var_list()
		)
	)
	
	on mi_none picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection].handler = 1
	)
	on mi_edt picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection].handler = 2
	)
	on mi_integer picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection].handler = 3
	)
	on mi_float picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection].handler = 4
	)
	on mi_pick picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection].handler = 5
	)
	on mi_bool picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection].handler = 6
	)
	on mi_custom picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection].handler = 7
	)
	
	on menu_vars open do
	(
		local ui_items = #(mi_on,mi_edit,mi_add,mi_dupl,mi_del,mi_none,mi_edt,mi_integer,mi_float,mi_pick,mi_bool,mi_custom)
		
		if(all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars.count!=0 AND santexToolbox_create.lbx_vars.selection!=0)then
		(
			local curr_var = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection]
			
			for i=1 to ui_items.count do ui_items[i].checked = false
			try(ui_items[curr_var.handler+5].checked = true)catch(false)
			mi_on.checked = curr_var.use as booleanClass
			
			for i=1 to ui_items.count do ui_items[i].enabled = true
		)else
		(
			for i=1 to ui_items.count do ui_items[i].enabled = false
			mi_add.enabled = true
		)
	)
)

rollout santexToolbox_create  "santexToolbox - Edit tool" width:380 height:280
(
	local ui_min_size=[380,280]
	--local for_items=#("Selection <array of nodes>",
		--					"Selection <single node>",
			--				"Copies from selection <single node>",
				--			"Instancies from selection <single node>",
					--		"<User specified>") -- dont forget to change also in santexToolbox_eval.ms (around line: 43)
	local for_items = santexToolbox_ui_for_items
	--local current_vars=#()
	--local bak_vars=#()
	local more_options=tool_options_struct()
	local adv_setts=adv_setts_struct()
	local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
	local orig_filename = ""
	local _close_dialog = true
	--global include_tools=#()
	
	edittext edt_name "* Tool name:" width:550
	edittext edt_id "* ID (no spaces!):  _tool_" width:550 tooltip:"Use only alphanumeric characters without spaces"
	edittext edt_desc "Description:" width:550 height:48 pos:[8,28]
	
		dropdownlist ddl_for "* Apply tool for:" items:for_items width:500 height:(for_items.count + 1) 
		label lbl1 ""
		label lbl2 ""
	button btn_options "..." width:50 height:24 tooltip:"More options (Not implemented)" enabled:true
	button btn_help "?" tooltip:"Show quick help" width:18 height:18 pos:[184,134]
	label lbl_code " Code:" pos:[206,134]
		button btn_include "Include tools (0)" tooltip:"Select tools which should be compiled before this tool" enabled:true width:110 height:18 pos:[242,134]

	listbox lbx_vars "Parameters (variables):" height:8 width:150
	button btn_vars_add "Add" width:45 tooltip:"Add new parameter"
	button btn_vars_edit "Edit" width:45 tooltip:"Edit selected parameter" enabled:false
	button btn_vars_up "/\\" width:28 height:16 tooltip:"Move selected parameter up in the list" enabled:false
	button btn_vars_down "\/" width:28 height:16 tooltip:"Move selected parameter down in the list" enabled:false
	button btn_vars_del "X" width:28 tooltip:"Delete selected parameter" enabled:false
							
		--edittext edt_vars "Constants:" width:550 height:60
		edittext edt_eval "" width:450 height:240
		edittext edt_eval_post "Post evaluation:" width:450 height:240 labelOnTop:true visible:true
							
	button btn_delete "Delete" width:60 height:32 tooltip:"Delete this tool"
	button btn_adv "..." width:40 height:32 tooltip:"Advanced settings"
	button btn_save "Save" width:48 height:32 tooltip:"Save but do not close dialog window"
	button btn_ok "EDIT" width:82 height:32 tooltip:"Save changes and close dialog window" --width:120
	button btn_cancel "Cancel" width:80 height:32 tooltip:"Discard all unsaved changes and close dialog window"
	
	
	
	
	
	
	
	include "santex_fnlib.ms"
	
	fn refresh_var_list_ui=
	(
		if(lbx_vars.selection!=0)then
		(
			btn_vars_edit.enabled = btn_vars_del.enabled = btn_vars_up.enabled = btn_vars_down.enabled = true
		)else
		(
			btn_vars_edit.enabled = btn_vars_del.enabled = btn_vars_up.enabled = btn_vars_down.enabled = false
		)
	)
	fn refresh_var_list=
	(
		local temparr=#()
		--current_vars = #()
		for i=1 to all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars.count do
		(
			if(all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[i].use=="false" OR\
				all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[i].use==false)then
			(
				append temparr (" ! "+all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[i].name+" = "+all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[i].value as string)
			)else
			(
				append temparr (all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[i].name+" = "+all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[i].value as string)
			)
			--append current_vars (all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[i])
		)
		lbx_vars.items=temparr
		refresh_var_list_ui()
	)
	fn add_new_var var=
	(
		append all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars var
		--append current_vars var
		refresh_var_list()
	)
	fn edit_sel_var var=
	(
		edit_var = lbx_vars.selection
		deleteItem all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars (edit_var)
		--deleteItem current_vars (edit_var)
		insertItem var all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars edit_var
		--insertItem var current_vars edit_var
		
		refresh_var_list()
	)
	
	fn resizeUI new_size=
	(
		ui_max_size=[(systemTools.GetScreenWidth() - 10),(systemTools.GetScreenHeight() - 100)]
		dlg_size=slib.dlg.resizelim santexToolbox_create new_size ui_min_size ui_max_size
		edt_name.width=((dlg_size.x-140-30)/2)-30
		edt_desc.width=dlg_size.x-96
		ddl_for.width=dlg_size.x-100
		lbx_vars.height=(dlg_size.y-254)
		lbx_vars.pos=[16,151]
		--lbl1.width=dlg_size.x-200
		--edt_vars.width=dlg_size.x-70-14
		--edt_vars.height=((dlg_size.y-200)/3)
		edt_eval.pos.y=lbx_vars.pos.y
		edt_eval.pos.x=184
		edt_eval.width=dlg_size.x-210
		edt_eval.height=dlg_size.y-220
		
		btn_cancel.pos.y=dlg_size.y-45
		btn_ok.pos.y=dlg_size.y-45
		btn_save.pos.y=dlg_size.y-45
		btn_cancel.pos.x=dlg_size.x-100
		btn_ok.pos.x=dlg_size.x-100-100-30+48
		btn_save.pos.x=dlg_size.x-100-100-30
		btn_adv.pos.x=dlg_size.x-100-100-30-50
		btn_adv.pos.y=dlg_size.y-45
		
		btn_options.pos=[(dlg_size.x-78),98]
		btn_vars_add.pos=[16,dlg_size.y-85]
		btn_vars_edit.pos=[16+45,dlg_size.y-85]
		btn_vars_del.pos=[135,dlg_size.y-85]
		btn_vars_up.pos=[16+45+45,dlg_size.y-85-3]
		btn_vars_down.pos=[16+45+45,dlg_size.y-85+13]
		
		edt_id.width=(dlg_size.x-edt_name.width-247)
		edt_id.pos=[(edt_name.width+220),5]
		
		btn_delete.pos = [16,(dlg_size.y-45)]
		
		--if(ddl_for.selection==8)then
		--(
		--	edt_eval_post.visible=false
		--)else
		--(
			
			edt_eval.height=(edt_eval.height/3)*2
			edt_eval_post.visible=true
			edt_eval_post.height=(edt_eval.height/3)
		edt_eval_post.pos.x=edt_eval.pos.x
		edt_eval_post.pos.y = edt_eval.pos.y+edt_eval.height+22
		edt_eval_post.width=edt_eval.width
		--)
	)
	
	fn getIncludedTools=
	(
		local return_arr = ""
		if(all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools.count>0)do
		(
			local c_include = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools
			for i=1 to c_include.count do
			(
				return_arr += c_include[i].id+"|"
			)
		)
		return return_arr
	)
	fn getParsedEval etext=
	(
		local parsed = ""
		for i=1 to etext.count do
		(
			if (etext[i]=="\n") then parsed += ";"
			else parsed += etext[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn getVarsSave=
	(
		local temp = ""
		local current_vars_edit = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars
		for i=1 to current_vars_edit.count do
		(
			local var = (current_vars_edit[i].caption + "~" +\
							current_vars_edit[i].name + "~" +\
							current_vars_edit[i].type as string + "~" +\
							current_vars_edit[i].handler as string + "~" +\
							(getParsedEval(current_vars_edit[i].value as string)) + "~" +\
							current_vars_edit[i].use as string + "~" +\
							(getParsedEval(current_vars_edit[i].custom_handler as string)))
			temp += (var + "|")
		)
		return temp
	)
	fn store_new_tool_file new_tool=
	(
		local filename = cfgdir + (all_toolsets[santexToolbox.ddl_toolset.selection].dir) +"\\"+new_tool.id+ ".ini"
		try(
			deleteFile orig_filename
		)catch()
		slib.file.init filename "Tool"
		
		local tool_eval = (getParsedEval (new_tool.code))
			local tool_post_eval = (getParsedEval (new_tool.post_eval))
		
		slib.csetting.save filename "General" "name" (new_tool.name)
		slib.csetting.save filename "General" "id" (new_tool.id)
		slib.csetting.save filename "General" "desc" (new_tool.desc)
		slib.csetting.save filename "General" "apply_for" (new_tool.apply_for)
		slib.csetting.save filename "General" "code" (tool_eval)
			slib.csetting.save filename "General" "post_eval" (tool_post_eval)
		slib.csetting.save filename "General" "vars" (getVarsSave())
			
		--saveMoreOptions()
		slib.csetting.save filename "Options" "num" (new_tool.apply_options.num)
		slib.csetting.save filename "Options" "rand_scale" (new_tool.apply_options.rand_scale)
		slib.csetting.save filename "Options" "rand_scale_min" (new_tool.apply_options.rand_scale_min)
		slib.csetting.save filename "Options" "rand_scale_max" (new_tool.apply_options.rand_scale_max)
		
			--slib.csetting.save filename "General" "options" (getOptionsSave new_tool.apply_options)
		slib.csetting.save filename "Settings" "internal" (new_tool.adv_setts.internal)
		slib.csetting.save filename "Settings" "hide_ctrl" (new_tool.adv_setts.hide_ctrl)
			
		slib.csetting.save filename "Include" "tools" (getIncludedTools())
	)
	fn create_new_tool=
	(
		if(edt_name.text!="" AND edt_id.text!="")then
		(
			more_options = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].apply_options
			adv_setts = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].adv_setts
			edt_desc_text=getParsedEval edt_desc.text
			local new_tool=tool_struct name:edt_name.text\
												id:edt_id.text\
												desc:edt_desc_text\
												apply_for:ddl_for.selection\
												code:edt_eval.text\
			post_eval:edt_eval_post.text\
												vars:all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars\
												apply_options:more_options\
												adv_setts:adv_setts\
												include_tools:all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools
				
			if _close_dialog do destroydialog santexToolbox_create
			santexToolbox.edit_sel_tool new_tool
			store_new_tool_file new_tool
			--print new_tool
		)else messagebox "Enter tool name and ID!" title:"Error"
	)
	fn getReParsedEval str=
	(
		local parsed = ""
		for i=1 to str.count do
		(
			if (str[i]==";") then parsed += "\n"
			else parsed += str[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn moveVar dir=
	(
		if (dir=="up") do dir=-1
		if (dir=="down") do dir=1
		if (lbx_vars.selection!=0 AND \
			(dir==-1 AND lbx_vars.selection!=1) OR \
			(dir==1 AND lbx_vars.selection!=lbx_vars.items.count)
		) do
		(
			local tempvar=all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[lbx_vars.selection]
			deleteItem all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars lbx_vars.selection
			insertItem tempvar all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars (lbx_vars.selection+dir)
			
			refresh_var_list()
			lbx_vars.selection = (lbx_vars.selection+dir)
			--refreshVarUI()
		)
	)
	on lbx_vars selected sel do
	(
		refresh_var_list_ui()
	)
	on lbx_vars rightClick do
	(
		--if(santexToolbox.lbx_tools.selection>0)do
			popUpMenu menu_vars
	)
	on ddl_for selected sel do
	(
		--btn_options.enabled=false
		--resizeUI (getDialogSize santexToolbox_create)
		--if (sel==4) do btn_options.enabled=true
	)
	on btn_vars_add pressed do ( try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_add_var.ms" )
	on btn_vars_edit pressed do ( try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_edit_var.ms" )
	on lbx_vars doubleclicked sel do ( try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_edit_var.ms" )
	on btn_vars_up pressed do moveVar "up"
	on btn_vars_down pressed do moveVar "down"
	on btn_vars_del pressed do
	(
		--try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_add_var.ms"
		if(querybox "Do you really want to delete selected parameter?" title:"santexToolbox")do
		(
			deleteItem all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars (lbx_vars.selection)
			refresh_var_list()
		)
	)
	on btn_delete pressed do
	(
		if(querybox "Do you really want to delete this tool?" title:"santexToolbox")do
		(
			local filename = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].id + ".ini" 
			deleteFile (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir  + "\\" + filename)
			deleteItem all_toolsets[santexToolbox.ddl_toolset.selection].tools (santexToolbox.lbx_tools.selection)
			santexToolbox.refresh_tools_list()
			destroydialog santexToolbox_create
		)
	)
	on btn_adv pressed do ( try(destroydialog santexToolbox_create_adv)catch(); filein "santexToolbox_create_adv.ms" )
	on btn_help pressed do ( try(destroydialog santexToolbox_quick_help)catch(); filein "santexToolbox_quick_help.ms" )
	on btn_include pressed do
	(
		--include_tools=#()
		try(destroydialog santexToolbox_include)catch()
		filein "santexToolbox_include.ms"
		--print include_tools
	)
	on btn_options pressed do ( try(destroydialog santexToolbox_more_options)catch(); filein "santexToolbox_more_options.ms" )
	on btn_ok pressed do
	(
		_close_dialog = true
		create_new_tool()
	)
	on btn_save pressed do
	(
		_close_dialog = false
		create_new_tool()
	)
	--on edt_name entered txt do create_new_tool()  
	--on edt_id entered txt do create_new_tool()
	on btn_cancel pressed do
	(		
		destroydialog santexToolbox_create
	)
	on santexToolbox_create close do
	(
		try(destroydialog santexToolbox_add_var)catch()
		try(destroydialog santexToolbox_create_adv)catch()
		try(destroydialog santexToolbox_quick_help)catch()
		try(destroydialog santexToolbox_more_options)catch()
		try(destroydialog santexToolbox_include)catch()
		
		slib.setting.save "santexToolbox_create.pos" (getDialogPos santexToolbox_create)
		slib.setting.save "santexToolbox_create.size" (getDialogSize santexToolbox_create)
	)
	on santexToolbox_create open do
	(
		orig_filename = cfgdir + (all_toolsets[santexToolbox.ddl_toolset.selection].dir) +"\\"+(all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].id)+ ".ini"
		slib.dlg.setSize santexToolbox_create (slib.setting.load "santexToolbox_create.size" (getDialogSize santexToolbox_create))
		resizeUI (slib.dlg.getSize santexToolbox_create)
		edit_tool = santexToolbox.lbx_tools.selection
		
		edt_name.text = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].name
		edt_id.text = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].id
		edt_desc.text = getReParsedEval (all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].desc)
		edt_eval.text = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].code
			edt_eval_post.text = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].post_eval
		ddl_for.selection = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].apply_for
			
		btn_include.text = ("Include tools ("+(all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].include_tools.count as string)+")")
		
		more_options = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].apply_options
		adv_setts = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].adv_setts
			--current_vars = #()
		--current_vars = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars
		--bak_vars = copyarray current_vars
		refresh_var_list()
			slib.dlg.setPos santexToolbox_create (slib.setting.load "santexToolbox_create.pos" [0,0])
	)
	on santexToolbox_create resized new_size do resizeUI new_size
)
createdialog santexToolbox_create style:#(#style_border,#style_titlebar,#style_resizing,#style_sysmenu) modal:true