-- TODO:
-- 
--
/*
fn getCorrectTool22=
	(
		local _current_tool = undefined
		local _sel = santexToolbox.lbx_tools.selection
		local _tools = all_toolsets[santexToolbox.ddl_toolset.selection].tools
		local _sel_name = santexToolbox.lbx_tools.selected
		--print _sel_name
		for i=1 to _tools.count do
		(
			local _tool = _tools[i]
			local match_string = filterString _tool.name _sel_name
			--print match_string
			if match_string == " " then
			(
				_current_tool = _tool
				print _tools.name
			)
		)
		
		return _current_tool
	)
*/
global santexToolbox_eval
try(destroydialog santexToolbox_eval)catch()
rollout santexToolbox_eval "Tool" width:220 height:60
(
	local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
	local ui_min_size = [220,60]
	--local current_tool = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection]
	--local current_included_tools = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools
	
	local handlers = #()
	
	--if santexToolbox_ui_hide_internal do
	--(
	--current_tool = getCorrectTool22()
	--print current_tool
	--current_included_tools = 
	--)
	
	button btn_eval "EXECUTE !" width:90 tooltip:"Compile and execute (evaluate) the code" pos:[12,5] height:32
	button btn_load "Load" height:15 tooltip:"Load saved config for current tool (Not implemented)" pos:[106,5] width:38 enabled:false
	button btn_save "Save" height:15 tooltip:"Save current tool's configuration (Not implemented)" pos:[106,21] width:38 enabled:false
	button btn_show_code "..." width:32 tooltip:"Show the code to be compiled and executed" pos:[147,5]  height:32
	button btn_show_desc "?" width:32 pos:[180,5] height:32 tooltip:"Show tool's description"
	subRollout subRollouts "" width:190 height:10
	--edittext lbl0 "" width:300 height:180 readOnly:true pos:[8,8]
	
	fn getCorrectTool22=
	(
		local _current_tool = undefined
		local _sel = santexToolbox.lbx_tools.selection
		local _tools = all_toolsets[santexToolbox.ddl_toolset.selection].tools
		local _sel_name = santexToolbox.lbx_tools.selected
		--print _sel_name
		for i=1 to _tools.count do
		(
			local _tool = _tools[i]
			--local match_string = filterString _tool.name _sel_name
			local match_string = findString _sel_name _tool.name
			--print match_string
			local _n = 1
			if _tool.adv_setts.internal do _n = 4
			if match_string == _n do
			(
				_current_tool = _tool
				--print _tools.name
				return _tool
			)
		)
		return _current_tool
	)
	local current_tool = getCorrectTool22()
	--if current_tool == undefined do messagebox "BOOOM !!!"
	local current_included_tools = current_tool.include_tools
	
	include "santex_fnlib.ms"
	--local code = ""
	include "santexToolbox_eval_create_ui.ms"

	fn get_nodes_code ctool=
	(
		local nodes_code = "#()"
		if(ctool.apply_for == 1) do nodes_code = "selection"
		if(ctool.apply_for == 2) do nodes_code = "#(selection[1])"
		if(ctool.apply_for == 3) do nodes_code = "#(selection[(random 1 (selection.count))])"
		if(ctool.apply_for == 4) do nodes_code = "selection"
		if(ctool.apply_for == 5) do nodes_code = "#(selection[1])"
		if(ctool.apply_for == 6) do nodes_code = "#(selection[(random 1 (selection.count))])"
		if(ctool.apply_for == 7) do nodes_code = "selection"
		if(ctool.apply_for == 8) do nodes_code = "#(selection[1])"
		if(ctool.apply_for == 9) do nodes_code = "#(selection[(random 1 (selection.count))])"
		return nodes_code
	)
	fn get_vars_code ctool=
	(
		local vars_code = ""
		for i=1 to ctool.vars.count do
		(
			local current_var = ctool.vars[i]
			if(current_var.use==true OR current_var.use=="true") AND \
				(current_var.type!=4 AND current_var.handler!=santexToolbox_ui_ddl_handler_user_specified)do
				(
					vars_code += "local "+current_var.name+"="+(current_var.value as string)+"\n"
				)
		)
		return vars_code
	)
	fn eval_code ctool=
	(
		--local code_header = "fn _tool_"+current_tool.id+" "+(get_nodes_code())
		local code = ""
		--code += get_nodes_code()
		
		code += "global _tool_"+ctool.id+"\n"
		code += "fn _tool_"+ctool.id+" _array=(\n"
		code += "undo off(\n"
		code += get_vars_code ctool
		
		local user_specified = santexToolbox_ui_user_specified -- change this according to number of items in array in santexToolbox_create.ms and santexToolbox_edit.ms
		
		if (ctool.apply_for != user_specified)do
		(
			code += "for _i=1 to _array.count do (\n"
			
			--code += "local _i = i\n"
			code += "local _this = _array[_i]\n"
		)
		--code += get_vars_code()
		code += ctool.code
		if (ctool.apply_for != user_specified)do code += "\n) --end for loop\n"
		--code += current_tool.code
		code += ctool.post_eval
		code += "\n) --end undo off\n"
		code += ") --end fn _tool_"+ctool.id+"\n"
		code += "\n\n\n\n\n"
			--code+="try(_tool_"+current_tool.id+" "+(get_nodes_code())+")catch(print \"FAILED: _tool_"+current_tool.id+" execution failed!\")\n"
--		code+="_tool_"+ctool.id+" "+(get_nodes_code ctool)+" \n"
		return code
	)
	fn build_and_evaluate_code=
	(
		--btn_eval.text = "WORKING ..."
		try(
			local code = ""
			
			if(current_included_tools.count>0)do
			(
				for i=current_included_tools.count to 1 by -1 do
				(
					code += (eval_code current_included_tools[i])
				)
			)
			
			code += (eval_code current_tool)
			--code += "--\n"
			code+="_tool_"+current_tool.id+" "+(get_nodes_code current_tool)
			return code
				--print ("OK: _tool_"+current_tool.id+" executed successfully")
			)catch(
				local txt = "Code execution (evaluation) FAILED !!!"
				messagebox txt title:"santexToolbox - ERROR"
				
				--print (eval_code current_tool)
			)
	)
	fn show_code=
	(
		global santexToolbox_eval_show_code
		rollout santexToolbox_eval_show_code "Compiled code" width:320 height:200
		(
			local ui_min_size = [320,200]
			edittext lbl0 "" width:300 height:180 readOnly:true pos:[8,8] text:" Compiling code ..."
			on santexToolbox_eval_show_code open do
			(
				--lbl0.text = " Compiling code ..."
				lbl0.text = build_and_evaluate_code()
				slib.dlg.setSize santexToolbox_eval_show_code (slib.setting.load "santexToolbox_eval_show_code.size" (getDialogSize santexToolbox_eval_show_code))
				ui_max_size=[(systemTools.GetScreenWidth() - 10),(systemTools.GetScreenHeight() - 100)]
				dlg_size=slib.dlg.resizelim santexToolbox_eval_show_code (slib.setting.load "santexToolbox_eval_show_code.size" (getDialogSize santexToolbox_eval_show_code)) ui_min_size ui_max_size
				
				lbl0.width = dlg_size.x-20
				lbl0.height = dlg_size.y-20
				slib.dlg.setPos santexToolbox_eval_show_code (slib.setting.load "santexToolbox_eval_show_code.pos" [0,0])
			)
			on santexToolbox_eval_show_code close do
			(
				slib.setting.save "santexToolbox_eval_show_code.pos" (getDialogPos santexToolbox_eval_show_code)
				slib.setting.save "santexToolbox_eval_show_code.size" (getDialogSize santexToolbox_eval_show_code)
			)
			on santexToolbox_eval_show_code resized new_size do
			(
				ui_max_size=[(systemTools.GetScreenWidth() - 10),(systemTools.GetScreenHeight() - 100)]
				dlg_size=slib.dlg.resizelim santexToolbox_eval_show_code new_size ui_min_size ui_max_size
				
				lbl0.width = dlg_size.x-20
				lbl0.height = dlg_size.y-20
			)
		)
		createdialog santexToolbox_eval_show_code style:#(#style_border,#style_titlebar,#style_sysmenu,#style_resizing)
	)
	fn getReParsedEval str=
	(
		local parsed = ""
		for i=1 to str.count do
		(
			if (str[i]==";") then parsed += "\n"
			else parsed += str[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn getParsedEval etext=
	(
		local parsed = ""
		for i=1 to etext.count do
		(
			if (etext[i]=="\n") then parsed += ";"
			else parsed += etext[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	
	fn resizeUI new_size=
	(
		ui_max_size=[(systemTools.GetScreenWidth() - 10),(systemTools.GetScreenHeight() - 100)]
		dlg_size=slib.dlg.resizelim santexToolbox_eval new_size ui_min_size ui_max_size
		
		subRollouts.height = dlg_size.y-70
		subRollouts.width = dlg_size.x-25
		try(
		subRollouts.pos.y = 45
		
			santexToolbox_eval.subRollouts.rollouts.subRolloutCtrl.width = subRollouts.width-30
		)catch()
		
	)
	
	
	
	on santexToolbox_eval open do
	(
		--santexToolbox_eval.title = "santexToolbox - " + current_tool.name
		santexToolbox_eval.title = current_tool.name
		
	
		slib.dlg.setSize santexToolbox_eval (slib.setting.load "santexToolbox_eval.size" (getDialogSize santexToolbox_eval))
		resizeUI (slib.dlg.getSize santexToolbox_eval)
		slib.dlg.setPos santexToolbox_eval (slib.setting.load "santexToolbox_eval.pos" [0,0])
			
		--print (create_ui_controls current_tool current_included_tools)
			
		--clearListener()
		--print (create_ui_controls current_tool current_included_tools)
			
		execute(create_ui_controls current_tool current_included_tools)
		
		if(santexToolbox_ui_show_ctrl==false OR current_tool.adv_setts.hide_ctrl==true) do
		(
			destroydialog santexToolbox_eval
			try(execute (build_and_evaluate_code()) )catch(execute (build_and_evaluate_code() ))
			
		)
		
-- additional resize based on generated ui		
		--ct = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].id
		ct = current_tool.id
		try(nh = execute("santexToolbox_eval.subRollouts.subRolloutCtrl_"+ct+".height"))catch(nh=0)
		ns = [0,0]
		ns.x = (getDialogSize santexToolbox_eval).x
		ns.y = nh
		if nh != 0 do ns.y = nh + 100
		if nh != 0 AND current_tool.include_tools.count > 0 do ns.y = nh + 100 + (current_tool.include_tools.count*20)
		resizeUI ns
	)
	on santexToolbox_eval close do
	(
		try(destroydialog santexToolbox_eval_show_code)catch()
		try(destroydialog santexToolbox_load_tool_cfg)catch()
				
		slib.setting.save "santexToolbox_eval.pos" (getDialogPos santexToolbox_eval)
		slib.setting.save "santexToolbox_eval.size" (getDialogSize santexToolbox_eval)
	)
	on btn_show_code pressed do
	(
		try(destroydialog santexToolbox_eval_show_code)catch()
		show_code()
	)
	on btn_save pressed do
	(		
		filein "santexToolbox_save_tool_cfg.ms"
	)
	on btn_load pressed do
	(
		filein "santexToolbox_load_tool_cfg.ms"
	)
	
	on btn_eval pressed do
	(
		--btn_eval.text = "WORKING ..."
		slib.workDlg.open()
		slib.workDlg.job "Working ..."
		max create mode
		try(execute (build_and_evaluate_code()) )catch(execute (build_and_evaluate_code() ))
			forceCompleteRedraw()
		slib.workDlg.close()
		--btn_eval.text = "EXECUTE NOW"
			
		/*
		try(
			execute (eval_code())
				--print ("OK: _tool_"+current_tool.id+" executed successfully")
			)catch(
				local txt = "Code execution (evaluation) FAILED !!!"
				messagebox txt title:"santexToolbox - ERROR"
				
				print (eval_code())
			)
		*/	
			
	)
	on btn_show_desc pressed do
	(
		local txt = getReParsedEval (all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].desc)
		if(txt=="" OR txt==" ")do txt="< Tool description ... >"
			
		messagebox txt title:"Tool description"
	)
	on santexToolbox_eval resized new_size do resizeUI new_size
)
--try(destroydialog santexToolbox_eval)catch()
createdialog santexToolbox_eval style:#(#style_border,#style_titlebar,#style_sysmenu,#style_resizing)