global santexToolbox_show_details

rollout santexToolbox_show_details "Details" width:680 height:220
(
	local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
	local old_name
	local old_desc
	
	label lbl0 ""
	--label lbl1 "" width:660
	edittext lbl1 "* Name: " width:480
	label lbl2 "" width:660
	label lbl5 "" width:660
	--label lbl3 "" width:660 height:32
	edittext lbl3 "Description: " width:480 height:56
	--label lbl4 ""
	label lbl8 "" width:660 height:28
	label lbl6 "" width:660
	label lbl7 "" width:660
	
	button btn_open_loc "Open folder" pos:[550,150] width:120 enabled:false
	button btn_delete "Delete this toolset" pos:[550,48] width:120 enabled:false visible:true
	button btn_update "Update details" pos:[550,180] width:120 enabled:false
	
	include "santex_fnlib.ms"
	
	fn getInternalCount tools=
	(
		local internal_count =0
		if(tools.count>0)do
		(
			for i=1 to tools.count do
			(
				if(tools[i].adv_setts.internal == true) do internal_count += 1
			)
		)
		return internal_count
	)
	
	on btn_delete pressed do
	(
		if (querybox "Do you really want to delete this Toolset?" title:"santexToolbox")do
		(
			destroydialog santexToolbox_show_details
			slib.workDlg.open()
			slib.workDlg.job "Loading tools ..."
			local filename = all_toolsets[santexToolbox.ddl_toolset.selection].dir + "-toolset.ini" 
			deleteFile (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir  + "\\" + filename)
			--print (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir  + "\\" + filename)
			--str = "rmDir C:\\doscmdtest\\"
			--hiddendoscommand str startpath:"$max" exitCode:&exitcode
			
			santexToolbox.refresh_toolset_list()
			slib.workDlg.close()
		)
	)
	on btn_open_loc pressed do
	(
		shelllaunch (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir) ""
	)
	on btn_update pressed do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].name = lbl1.text
		all_toolsets[santexToolbox.ddl_toolset.selection].desc = lbl3.text
		destroydialog santexToolbox_show_details
		
		local ccfg_filename = ((cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir + "\\") +all_toolsets[santexToolbox.ddl_toolset.selection].dir+"-toolset.ini")
		slib.csetting.save ccfg_filename "General" "name" lbl1.text
		slib.csetting.save ccfg_filename "General" "desc" lbl3.text
		
		slib.workDlg.open()
		slib.workDlg.job "Loading tools ..."
		santexToolbox.refresh_toolset_list()
		slib.workDlg.close()
		
	)
	on santexToolbox_show_details open do
	(
		if(santexToolbox.ddl_toolset.selection>0) do
		(
			santexToolbox_show_details.title = ("Details: '" + all_toolsets[santexToolbox.ddl_toolset.selection].name + "'")
			
			--lbl1.text = "Name: " + all_toolsets[santexToolbox.ddl_toolset.selection].name
			lbl1.text = all_toolsets[santexToolbox.ddl_toolset.selection].name
			old_name = all_toolsets[santexToolbox.ddl_toolset.selection].name
			lbl2.text = "* Author: " + all_toolsets[santexToolbox.ddl_toolset.selection].author
			lbl3.text = all_toolsets[santexToolbox.ddl_toolset.selection].desc
			old_desc = all_toolsets[santexToolbox.ddl_toolset.selection].desc
			
			local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
			lbl8.text = "* Folder: " + (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir + "\\")
			lbl5.text = "Date created: " + all_toolsets[santexToolbox.ddl_toolset.selection].created
			lbl6.text = "Total number of tools: " + all_toolsets[santexToolbox.ddl_toolset.selection].tools.count as string
			
			local internal_tools_count = getInternalCount (all_toolsets[santexToolbox.ddl_toolset.selection].tools)
			lbl7.text = "Number of 'internal' tools: " + internal_tools_count as string
			
			btn_open_loc.enabled=btn_delete.enabled=btn_update.enabled=true
		)
	)
)
createdialog santexToolbox_show_details modal:true